#!/usr/bin/perl

#
# COMCHAT : comchat.cgi - 2011/10/02
# Copyright (c) KentWeb
# http://www.kent-web.com/
#
# REBUILD()
#
#  COMCHAT v5.01 2021/03/12
#  Edited by Hamel(TRANSFORM) Since 2012
#  https://www.transformsite.com/
#
# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);

# ݒt@CF
require "./init.cgi";
my %cf = set_init();

# f[^
my %in = parse_form();

# 
&deny_host;
if ($in{mode} eq 'form') { form1(); }
if ($in{mode} eq 'into') { form2(); }
if ($in{comment} && $in{mode} eq 'regist') { regist(); }
if ($in{mode} eq 'out') { room_out(); }
if ($in{mode} eq 'rank') { rank_list(); }
if ($in{mode} eq 'grad') { grad_disp(); }
chat_data();

#-----------------------------------------------------------
#  tH[1 : 
#-----------------------------------------------------------
sub form1 {
	# NbL[擾
	my ($ck_nam,$ck_eml,$ck_col,$ck_ret,$ck_lin,$ck_grad) = get_cookie();
	$ck_col = $ck_col ne '' ? $ck_col : 0;
	$ck_ret = $ck_ret ne '' ? $ck_ret : $cf{retime_defo};
	$ck_lin = $ck_lin ne '' ? $ck_lin : $cf{lines_defo};
	$ck_grad = $ck_grad ne '' ? $ck_grad : 0;

	my ($op_retime,$op_lines,$colors,$op_grad);
	foreach (@{$cf{retime}}) {
		if ($ck_ret == $_) {
			$op_retime .= qq|<option value="$_" selected>$_b\n|;
		} else {
			$op_retime .= qq|<option value="$_">$_b\n|;
		}
	}
	foreach (@{$cf{lines}}) {
		if ($ck_lin == $_) {
			$op_lines .= qq|<option value="$_" selected>$_s\n|;
		} else {
			$op_lines .= qq|<option value="$_">$_s\n|;
		}
	}
	foreach (0 .. $#{$cf{colors}}) {
		my ($col,undef) = split(/,/, $cf{colors}->[$_]);
		if ($ck_col == $_) {
			$colors .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$colors .= qq|<input type="radio" name="color" value="$_">|;
		}
		$colors .= qq|<span style="color:$col"></span>\n|;

		if ($_ == int(@{$cf{colors}}/2)-1) { $colors .= "<br>\n"; }
	}

	# Of[Vv_E
        my @grd = split(/\s+/, $cf{GradStartColor});
        my @grdn = split(/\s+/, $cf{GradName});
	foreach (0 .. $#grdn) {
                if ($ck_grad == $_) {
			$op_grad .= qq|<option value="$_" style="color:$grd[$_]" selected>$grdn[$_]\n|;
		} else {
			$op_grad .= qq|<option value="$_" style="color:$grd[$_]">$grdn[$_]\n|;
		}
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!admin_cgi!/$cf{admin_cgi}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!colors!/$colors/g;
	$tmpl =~ s/!name!/$ck_nam/g;
	$tmpl =~ s/!email!/$ck_eml/g;
	$tmpl =~ s/<!-- op_retime -->/$op_retime/g;
	$tmpl =~ s/<!-- op_lines -->/$op_lines/g;
	$tmpl =~ s/<!-- op_grad -->/$op_grad/g;

	print "Content-type: text/html; charset=shift-jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  tH[2 : tH[
#-----------------------------------------------------------
sub form2 {
	&regist('into');

	# NbL[ۑ
	set_cookie($in{name},$in{email},$in{color},$in{retime},$in{lines},$in{gradation});

	my ($op_retime,$op_lines,$op_colors,$op_faces,$op_grad);
	foreach (@{$cf{retime}}) {
		if ($in{retime} == $_) {
			$op_retime .= qq|<option value="$_" selected>$_b\n|;
		} else {
			$op_retime .= qq|<option value="$_">$_b\n|;
		}
	}
	foreach (@{$cf{lines}}) {
		if ($in{lines} == $_) {
			$op_lines .= qq|<option value="$_" selected>$_s\n|;
		} else {
			$op_lines .= qq|<option value="$_">$_s\n|;
		}
	}
	foreach (0 .. $#{$cf{colors}}) {
		my (undef,$nam) = split(/,/, $cf{colors}->[$_]);
		if ($in{color} == $_) {
			$op_colors .= qq|<option value="$_" selected>$nam\n|;
		} else {
			$op_colors .= qq|<option value="$_">$nam\n|;
		}
	}
	foreach (@{$cf{faces}}) {
		$op_faces .= qq|<option value="$_">$_\n|;
	}

	# Of[Vv_E
        my @grd = split(/\s+/, $cf{GradStartColor});
        my @grdn = split(/\s+/, $cf{GradName});
	foreach (0 .. $#grdn) {
                if ($in{gradation} == $_) {
			$op_grad .= qq|<option value="$_" style="color:$grd[$_]" selected>$grdn[$_]\n|;
		} else {
			$op_grad .= qq|<option value="$_" style="color:$grd[$_]">$grdn[$_]\n|;
		}
	}

	open(IN,"$cf{tmpldir}/form2.html") or &error("open err: form2.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/<!-- ranking_begin -->.+<!-- ranking_end -->//s if ($cf{ranking});
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!email!/$in{email}/g;
	$tmpl =~ s/!enam!/&url_encode($in{name})/eg;
	$tmpl =~ s/<!-- op_retime -->/$op_retime/g;
	$tmpl =~ s/<!-- op_lines -->/$op_lines/g;
	$tmpl =~ s/<!-- op_faces -->/$op_faces/g;
	$tmpl =~ s/<!-- op_colors -->/$op_colors/g;
	$tmpl =~ s/<!-- op_grad -->/$op_grad/g;

	print "Content-type: text/html; charset=shift-jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  L\
#-----------------------------------------------------------
sub chat_data {
	my $meta;
	if ($in{retime} != 0) {
		my $enam = &url_encode($in{name});
		$meta = qq|<meta http-equiv="refresh" content="$in{retime}; url=$cf{chat_cgi}?retime=$in{retime}&lines=$in{lines}&name=$enam">|;
	}

	# [h/s
	my $retime = $in{retime} ? "$in{retime}b" : "蓮";
	$in{lines} ||= $cf{lines_defo};

	# ݎ
	my ($num,$member) = &member;

	open(IN,"$cf{tmpldir}/data.html") or &error("open err: data.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!member!/$member/g;
	$tmpl =~ s/!num!/$num/g;
	$tmpl =~ s/!retime!/$retime/g;
	$tmpl =~ s/!lines!/$in{lines}/g;
	$tmpl =~ s/<!-- meta_refresh -->/$meta/;
	$tmpl =~ s/!lines!/$in{lines}/g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		error("ev[gsł");
	}

	print "Content-type: text/html; charset=shift-jis\n\n";
	print $head;

	my $i;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		$i++;
		my ($date,$name,$eml,$com,$col,undef,undef) = split(/<>/);

		my $tmp = $loop;
		$tmp =~ s|!name!|<span style="color:$col">$name</span>|g;
		$tmp =~ s|!comment!|<span style="color:$col">$com</span>|g;
		$tmp =~ s/!date!/$date/g;
		print $tmp;

		# \
		last if ($i >= $in{lines});
	}
	close(IN);

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub regist {
	my $job = shift;

	# O̓͂Ȃ΃G[
	if ($in{name} eq "") { &error("O̓͂܂"); }

	# /zXg
	my $host = $ENV{REMOTE_ADDR};

	# Ԏ擾
	my ($sec,$min,$hour,$mday,$mon,$year) = localtime();
	my $date = sprintf("%04d/%s/%s-%02d:%02d:%02d",$year+1900,$mon+1,$mday,$hour,$min,$sec);

 	#LOf[V
    	if ($cf{grad}) {
    		$in{comment} = &CreatGradation("$in{comment}");
    	}

	my ($name,$email,$color,$grad);
	if ($job eq 'into') {
		$in{comment} = "<b>$in{name}</b>$cf{msg_in}";
		$email = "";
		$name  = $cf{master};
		$color = $cf{rep_color};

	} elsif ($job eq 'out') {
		$in{comment} = "<b>$in{name}</b>$cf{msg_out}";
		$email = "";
		$name  = $cf{master};
		$color = $cf{rep_color};

	} else {
		if ($in{email} eq "") {
			$name = "$cf{pointer} <b>$in{name}</b>";
		} else {
			$name = qq|<a href="mailto:$in{email}">$cf{pointer}</a> <b>$in{name}</b>|;
		}
		$email = $in{email};
		$color = (split(/,/, $cf{colors}->[$in{color}]))[0];
        	my @grd = split(/\s+/, $cf{GradStartColor});
		$grad = $grd[$_];

		# LO
		if ($cf{rankkey}) { &ranking; }
	}

	# OJ
	open(DAT,"+< $cf{logfile}") || &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my @data = <DAT>;

	## clear Ɠ͂邱ƂŎ̋L폜
	if ($in{comment} eq 'clear'){
		my @temp;
		my $match;
		foreach (@data) {
			my ($hos) = (split(/<>/))[5];
			if ($host eq $hos) { $match = 1; }
			else { push(@temp,$_); }
		}
		if ($match) {
			@data = @temp;
			$in{comment} = "All Clear (^-^)v";
		}
	}

	# őL
	while ($cf{maxlog} <= @data) { pop(@data); }

	$in{comment} .= " $in{face}" if ($in{face});
	$in{comment} =~ s|\(\*\O\O\*\)|(<span style="color:red">*</span>OO<span style="color:red">*</span>)|g;

	# OtH[}bgčXV
	unshift (@data,"$date<>$name<>$email<>$in{comment}<>$color<>$host<>$grad<>\n");
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  Of[VTv\
#-----------------------------------------------------------
sub grad_disp {

	# ev[gF
	open(IN,"$cf{tmpldir}/grad_sample.html") or &error("open err: grad_sample.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("ev[gsł");
	}

	# u
	foreach ($head, $foot) {
		s/!chat_cgi!/$cf{chat_cgi}/g;
		s/!version!/$cf{version}/g;
	}

	# ʓWJ
	print "Content-type: text/html\n\n";
	print $head;

	my @gradcol1;
	my @gradcol2;

	@gradcol1 = split(/\s+/, $cf{GradStartColor});
	@gradcol2 = split(/\s+/, $cf{GradName});
		my $i = 0;
		foreach (0 .. $#gradcol1) {
			$cf{gradnumber} = $i;
			$i++;

		my $grdc = &CreatGradation("");

		my $tmp = $loop;
		$tmp =~ s|!name!|<span style="color:$gradcol1[$_]">$gradcol2[$_]</span>|g;
		$tmp =~ s|!gradation!|$grdc|g;
		print $tmp;
	}

	# tb^
	&footer($foot);
	exit;
}

#-----------------------------------------------------------
#  Of[V(AJnFAԐFAIF)
#-----------------------------------------------------------
sub GradStr2{
    my ($Str, $ColorFrom, $ColorIn, $ColorTo, $Len, $FromLen, $ToLen
        , $FromStr, $ToStr, $FromTagStr, $ToTagStr, $i, @S);

    $Str = $_[0];
    $ColorFrom = $_[1];
    $ColorIn = $_[2];
    $ColorTo = $_[3];

    $Len = &Klength($Str);

    $FromLen = int($Len / 2);
    $ToLen = $Len - $FromLen;

    $FromStr = "";
    for($i = 1;$i <= $FromLen;$i++){
        $FromStr = $FromStr . &KcharAt($Str, $i);
    }

    $ToStr = "";
    for($i = $FromLen + 1;$i <= $Len;$i++){
        $ToStr = $ToStr . &KcharAt($Str, $i);
    }

    if($FromLen == $ToLen){
        $ToStr = &KcharAt($FromStr, $FromLen) . $ToStr;
    }else{
        $FromStr = $FromStr . &KcharAt($ToStr, 1);
    }

    $FromTagStr = &GradStr($FromStr, $ColorFrom, $ColorIn);
    $ToTagStr = &GradStr($ToStr, $ColorIn, $ColorTo);

    @S = split(/<\/span>/, $ToTagStr);
    shift(@S);
    $ToTagStr = join("</span>", @S, "");

    return ($FromTagStr . $ToTagStr);
}

#-----------------------------------------------------------
#  Of[V(AJnFAIF)
#-----------------------------------------------------------
sub GradStr{
    my ($Str, $ColorFrom, $ColorTo, %Red, %Green, %Blue, $Len
        , $TagStr, $i, $StaTag, $EndTag, $FColor);

    $Str = $_[0];
    $ColorFrom = $_[1];
    $ColorTo = $_[2];
    
    $StaTag = '<span style="color:#';
    $EndTag = '</span>';

    $Len = &Klength($Str);

    if(substr($ColorFrom, 0, 1) eq "#"){
        $ColorFrom = substr($ColorFrom, 1, 6);
    }
    if(substr($ColorTo, 0, 1) eq "#"){
        $ColorTo = substr($ColorTo, 1, 6);
    }

    $Red{'from'} = hex(substr($ColorFrom, 0, 2));
    $Green{'from'} = hex(substr($ColorFrom, 2, 2));
    $Blue{'from'} = hex(substr($ColorFrom, 4, 2));

    $Red{'to'} = hex(substr($ColorTo, 0, 2));
    $Green{'to'} = hex(substr($ColorTo, 2, 2));
    $Blue{'to'} = hex(substr($ColorTo, 4, 2));

    $Red{'level'} = &GetLev($Red{'from'}, $Red{'to'}, $Len - 1);
    $Green{'level'} = &GetLev($Green{'from'}, $Green{'to'}, $Len - 1);
    $Blue{'level'} = &GetLev($Blue{'from'}, $Blue{'to'}, $Len - 1);

    $Red{'color'} = $Red{'from'} - $Red{'level'};
    $Green{'color'} = $Green{'from'} - $Green{'level'};
    $Blue{'color'} = $Blue{'from'} - $Blue{'level'};

    $TagStr = "";
    for ($i = 0 ;$i <= $Len - 1;$i++){
        $Red{'color'} = $Red{'color'} + $Red{'level'};
        $Green{'color'} = $Green{'color'} + $Green{'level'};
        $Blue{'color'} = $Blue{'color'} + $Blue{'level'};
        if ($i < $Len - 1 ){
            $FColor = sprintf("%02X", $Red{'color'}) 
                    . sprintf("%02X", $Green{'color'})
                    . sprintf("%02X", $Blue{'color'})
        } else {
            $FColor = $ColorTo;
        }
        $FColor = lc $FColor;

        $TagStr = $TagStr . $StaTag . $FColor . ';">' . &KcharAt($Str, $i + 1) . $EndTag;
    }
    return ($TagStr);
}

#-----------------------------------------------------------
#  Of[VKZo (JnF,IF,iK)
#-----------------------------------------------------------
sub GetLev{
    my ($F, $T, $n, $sa, $am);
    $F = $_[0];
    $T = $_[1];
    $n = $_[2];
    $sa = $T - $F;
    if ($n == 0) {$am = 0;}
    else {$am = $sa % $n; $am = ($sa - $am) / $n;}
    return ($am);
}

#-----------------------------------------------------------
#--VtgJISR[hF
#--PoCg : 0x81 - 0x9F, 0xE0 - 0xFC
#--QoCg : 0x40 - 0x7E, 0x80 - 0xFC
#--dtbR[hF
#--0x80-0xff
#  {ꍬ݂̒̕擾(Shift JIS)()
#-----------------------------------------------------------
sub Klength{
    my ($moji, $klen, $ki, $c, $cb);
    $moji = $_[0];
    $klen = 0;
    for ($ki=0; $ki<length($moji); $ki++){
        $c = substr($moji, $ki, 1);
        $cb = ord($c);
        if ((($cb>=0x81) && ($cb<=0x9F)) || (($cb>=0xE0) && ($cb<=0xFC))){ $ki++; }
        $klen++;
    }
    return ($klen);
}

#----------------------------------------------------------------------
#  {ꍬ݂̕񂩂w肵P擾(Shift JIS)(Aʒu)
#----------------------------------------------------------------------
sub KcharAt{
    my ($moji, $pos, $len, $ai, $c, $cb);
    $moji = $_[0];
    $pos = $_[1];
    $len = 1;
    for($ai=0; $ai<length($moji); $ai++){
        $c = substr($moji, $ai, 1);
        $cb = ord($c);
        if ((($cb>=0x81) && ($cb<=0x9F)) || (($cb>=0xE0) && ($cb<=0xFC))){
            $c = $c . substr($moji, $ai + 1, 1);
            $ai++;
        }
        if ($pos == $len){last;}
        $len++;
    }
    return ($c);
}

#----------------------------------
#Of[V
#----------------------------------
sub CreatGradation {
    my($OrgStr, $BufStr,$S,@ArrayStr,$random,@gscol,@gmcol,@gecol,@chk,$i,@NewArr, $flg);
    $OrgStr = $_[0];

    if (!$cf{gradstr}) {
        return $OrgStr;
    }
    $OrgStr =~ s/<BR>/\r/g;
    $OrgStr =~ s/<br>/\r/g;
    $OrgStr =~ s/<br \/>/\r/g;
    @ArrayStr = split("\r", $OrgStr);

    @gscol = split(/\s+/, $cf{GradStartColor});
    @gmcol = split(/\s+/, $cf{GradMidColor});
    @gecol = split(/\s+/, $cf{GradEndColor});

    foreach $S (@ArrayStr){
        $i = 0;
        if ($in{randgrad} eq "random") {
            @chk = split(/\s+/, $cf{GradStartColor});
            $random = @chk;
            $i = int(rand($random));
        } elsif($in{gradation} ne '') {
            $i = $in{gradation};
        } else {
            $i = $cf{gradnumber};
            $flg = 1;
        }

        if ($flg) {
        $BufStr = $S;

            $BufStr = &GradStr2($BufStr, @gscol[$i], @gmcol[$i], @gecol[$i]);

            $S = $BufStr;
        } else {
            if ($S =~ /^$cf{gradstr}([^\r]*)/){
            $BufStr = $1;

                $BufStr = &GradStr2($BufStr, @gscol[$i], @gmcol[$i], @gecol[$i]);

                $S =~ s/^$cf{gradstr}([^\r]*)/$BufStr/g;

            }
        }
        push(@NewArr,$S);
    }
    return join("<br />", @NewArr);
}

#-----------------------------------------------------------
#  ގ
#-----------------------------------------------------------
sub room_out {
	&regist('out');
	&member('out');

	open(IN,"$cf{tmpldir}/out.html") or &error("open err: out.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!name!/$in{name}/g;

	print "Content-type: text/html; charset=shift-jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;

	print "Content-type: text/html; charset=shift-jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  ݎǗ
#-----------------------------------------------------------
sub member {
	my $job = shift;

	# /IP擾
	my $now = time;
	my $addr = $ENV{REMOTE_ADDR};

	my ($i,$member,$flg,@log);
	open(DAT,"+< $cf{memfile}") or &error("open err: $cf{memfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($time,$name,$ip) = split(/<>/);

		# 60bȏ㔭̂Ȃ҂͍폜
		if ($now - 60 > $time) {
			$flg = 1;
			next;
		}

		if ($addr eq $ip) {
			$flg = 2;

			# ގҍ폜
			if ($job eq 'out') {
				next;

			# /OXV
			} else {
				$name = $in{name};
				$_ = "$now<>$name<>$addr<>\n";
			}
		}

		# XVpzɒǉ
		push(@log,$_);

		# Qҕ\p쐬
		if ($i % 2) {
			$member .= "$name";
			$i++;
		} else {
			$member .= "$name";
			$i++;
		}
	}

	# VKQҒǉ
	if (!$flg && $job ne 'out' && $in{name} ne '') {
		$flg = 3;
		push(@log,"$now<>$in{name}<>$addr<>\n");
		$member = $i % 2 ? "$member$in{name}" : "$member$in{name}";
	}

	# QҐ
	my $num = @log;

	# t@CXV
	if ($job || $flg) {
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
	}
	close(DAT);

	return ($num,$member);
}

#-----------------------------------------------------------
#  IPANZX
#-----------------------------------------------------------
sub deny_host {
	my $addr = $ENV{REMOTE_ADDR};
	my $flg;
	open(IN,"$cf{denyfile}") || &error("open err: $cf{denyfile}");
	while (<IN>) {
		chomp;
		next if (!$_);
		s/\*/\.\*/g;
		if ($addr =~ /$_/i) { $flg++; last; }
	}
	close(IN);

	&error('\󂠂܂񂪌݂pł܂') if ($flg);
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub ranking {
	my $now = time;

	my ($flg,@log);
	open(DAT,"+< $cf{rankfile}") || &error("open err: $cf{rankfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($name,$kaisu,$time) = split(/<>/);
		next if ($now - $time > $cf{limit}*24*60*60);

		if ($name eq $in{name}) {
			$flg++;
			$kaisu++;
			$_ = "$name<>$kaisu<>$now<>\n";
		}
		push(@log,$_);
	}
	if (!$flg) { unshift(@log,"$in{name}<>1<>$now<>\n"); }
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  URLGR[h
#-----------------------------------------------------------
sub url_encode {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:1em;text-align:center;font-family:verdana,helvetica,arial;font-size:12px;">
- <a href="http://www.kent-web.com/" target="_top">COMCHAT</a> -<br />
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: com_chat=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{com_chat}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  LO
#-----------------------------------------------------------
sub rank_list {
	# Nt@Cǂݍ
	my (@sort,@data);
	open(IN,"$cf{rankfile}") || &error("open err: $cf{rankfile}");
	while(<IN>) {
		my ($name,$count) = split(/<>/);

		push(@sort,$count);
		push(@data,$_);
	}
	close(IN);

	# \[g
	@data = @data[sort {$sort[$b] <=> $sort[$a]} 0 .. $#sort];

	open(IN,"$cf{tmpldir}/rank.html") or &error("open err: rank.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!limit!/$cf{limit}/g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# ʕ\
	print "Content-type: text/html; charset=shift-jis\n\n";
	print $head;

	my ($i,$b_c,$b_r);
	foreach (@data) {
		$i++;
		my ($name,$count) = split(/<>/);
		my $rank = $count == $b_c ? $b_r : $i;

		my $tmp = $loop;
		$tmp =~ s/!rank!/$rank/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!count!/$count/g;
		print $tmp;

		$b_r = $rank;
		$b_c = $count;
	}

	print $foot;
	exit;
}


